<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<HTML>
<HEAD>
<%@ page 
	language="java" contentType="text/html; charset=ISO-8859-1"
	pageEncoding="ISO-8859-1"
	import="java.net.URL" 
	import="javax.naming.InitialContext" 
	import="com.tivoli.am.fim.echo.service.*" 
%>
<META http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<META name="GENERATOR" content="IBM Software Development Platform">
<META http-equiv="Content-Style-Type" content="text/css">
<LINK href="theme/Master.css" rel="stylesheet" type="text/css">
<TITLE>ITFIM Web Services Security Demonstration</TITLE>
</HEAD>
<BODY>

<%!
	public EchoService_PortType getEchoService(String tokenType, String urlSpecification) throws Exception {
		InitialContext initialContext = new InitialContext();
		EchoService_ServiceLocator serviceLocator = (EchoService_ServiceLocator) initialContext.lookup("java:comp/env/service/EchoService");
		
		URL url = new URL(urlSpecification);
		
		if (tokenType.equals("None")) {
			return serviceLocator.getEchoServiceNoToken(url);
		} else if (tokenType.equals("SAML v1.1")) {
			return serviceLocator.getEchoServiceSAML11(url);
		} else if (tokenType.equals("SAML v2.0")) {
			return serviceLocator.getEchoServiceSAML20(url);
		} else if (tokenType.equals("Username")) {
			return serviceLocator.getEchoServiceUsername(url);
		} else if (tokenType.equals("X.509")) {
			return serviceLocator.getEchoServiceX509(url);
		} else {
			return serviceLocator.getEchoServiceNoToken(url);
		}
	}
%>

<%
	String submitType = request.getParameter("Submit");

	String inputText = request.getParameter("Input");
	if (inputText == null) {
		inputText = "Hello World!";
	}
	
	String tokenType = request.getParameter("TokenType");
	
	if (tokenType == null || tokenType.length() == 0) {
		tokenType = "None";
	}
	
	String noneSelected = tokenType.equals("None") ? "SELECTED" : "";
	String saml11Selected = tokenType.equals("SAML v1.1") ? "SELECTED" : "";
	String saml20Selected = tokenType.equals("SAML v2.0") ? "SELECTED" : "";
	String usernameSelected = tokenType.equals("Username") ? "SELECTED" : "";
	String x509Selected = tokenType.equals("X.509") ? "SELECTED" : "";
	
	String urlSpecification = request.getParameter("Url");
	if (urlSpecification == null || urlSpecification.length() == 0) {
		urlSpecification = "http://localhost:9080/EchoApplication/services/EchoServiceNoToken";
	}

	String resultText = "";
	String errorMessage = "";

	if (request.getMethod().equals("POST")) {
		try {
			EchoService_PortType echoService = getEchoService(tokenType, urlSpecification);
			
			if (submitType.equals("To Lower")) {
				resultText = echoService.toLowerCase(inputText);
			} else if (submitType.equals("To Upper")) {
				resultText = echoService.toUpperCase(inputText);
			} else if (submitType.equals("Echo")) {
				resultText = echoService.echo(inputText);
			} else if (submitType.equals("Who Am I")) {
				resultText = echoService.whoAmI();
			}
		}
		
		catch (Exception exception) {
			errorMessage = exception.toString();
		}
	}
%>

	<SCRIPT TYPE="text/javascript">
		function updateURL() {
			switch (document.Echo.TokenType.value) {
				case "None":
					document.Echo.Url.value = "http://localhost:9080/EchoApplication/services/EchoServiceNoToken";
					break;
					
				case "SAML v1.1":
					document.Echo.Url.value = "http://localhost:9080/EchoApplication/services/EchoServiceSAML11";
					break;
					
				case "SAML v2.0":
					document.Echo.Url.value = "http://localhost:9080/EchoApplication/services/EchoServiceSAML20";
					break;
					
				case "Username":
					document.Echo.Url.value = "http://localhost:9080/EchoApplication/services/EchoServiceUsername";
					break;
					
				case "X.509":
					document.Echo.Url.value = "http://localhost:9080/EchoApplication/services/EchoServiceX509";
					break;
					
				default:
					document.Echo.Url.value = "";
			}			
		}
	</SCRIPT>
	
	<FORM NAME="Echo" METHOD="POST">
		<TABLE>
			<TR><TD><P><STRONG>Input:</STRONG></P></TD></TR>
			<TR><TD><TEXTAREA NAME="Input" ROWS="10" COLS="80"><%=inputText%></TEXTAREA></TD></TR>
			<TR><TD><STRONG>Result:</STRONG></TD></TR>
			<TR><TD><TEXTAREA NAME="Result" ROWS="10" COLS="80" READONLY><%=resultText%></TEXTAREA></TD></TR>
			<TR>
				<TD>
					<BR>
					<STRONG>Token Type:</STRONG>
	        		<SELECT NAME="TokenType" ONCHANGE="updateURL();">
        				<OPTION VALUE="None" <%=noneSelected%>>None</OPTION>
        				<OPTION VALUE="SAML v1.1" <%=saml11Selected%>>SAML v1.1</OPTION>
        				<OPTION VALUE="SAML v2.0" <%=saml20Selected%>>SAML v2.0</OPTION>
        				<OPTION VALUE="Username" <%=usernameSelected%>>Username</OPTION>
        				<OPTION VALUE="X.509" <%=x509Selected%>>X.509</OPTION>
    				</SELECT>
					<BR>
				</TD>
			</TR>
			<TR>
				<TD>
					<BR>
					<STRONG>Echo web service URL:</STRONG>
					<INPUT TYPE="TEXT" NAME="Url" SIZE="80" VALUE="<%=urlSpecification%>">
					<BR>
				</TD>
			</TR>
			<TR>
				<TD>
					<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="To Lower">
					<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="To Upper">
					<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Echo">
					<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Who Am I">
				</TD>
			</TR>
		</TABLE>		
	</FORM>
<%=errorMessage%>
</BODY>
</HTML>
